﻿using Microsoft.SharePoint;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;

namespace WingtipToysFieldTypes.FieldTypeClasses
{
    class CustomerPhoneNumber : SPFieldText
    {
        public CustomerPhoneNumber(SPFieldCollection fields, string fieldName)
            : base(fields, fieldName) { }

        public CustomerPhoneNumber(SPFieldCollection fields, string typeName, string displayName)
            : base(fields, typeName, displayName) { }

        // add validation to ensure proper formatting
        public override string GetValidatedString(object value)
        {
            string UserInput = value.ToString();
            string PN_RegularExpression = @"^\+\d{1,2}\-\(0\)";
            if ((this.Required || !string.IsNullOrEmpty(UserInput)) & (!Regex.IsMatch(UserInput, PN_RegularExpression)))
            {
                throw new SPFieldValidationException("Phone Number must be formatted like +[CountryCode]-(0)...");
            }
            return base.GetValidatedString(value);
        }
    }
}
