﻿var _validationLabel = null;
var _phoneNrBox = null;

(function () {
    if (typeof CustomPhoneNumberFieldTemplate == "object") {
        return;
    }
    window.CustomPhoneNumberFieldTemplate = (function () {
        return {
            SPFieldPhoneNumber_Edit: function (rCtx) {
                if (rCtx == null)
                    return '';
                var _myData = SPClientTemplates.Utility.GetFormContextForCurrentField(rCtx);

                if (_myData == null || _myData.fieldSchema == null) {
                    return '';
                }
                var _inputId_PhoneNr = _myData.fieldName + '_' + _myData.fieldSchema.Id + '_$phoneNrField_PhoneNr';
                var _inputId_Div = _myData.fieldName + '_' + _myData.fieldSchema.Id + '_$phoneNrField_Div';
                var _inputId_ValidationLabel = _myData.fieldName + '_' + _myData.fieldSchema.Id + '_$phoneNrField_ValidationError';

                var _value = _myData.fieldValue != null ? _myData.fieldValue : '';
                var listItem = rCtx['CurrentItem'];

                var validators = new SPClientForms.ClientValidation.ValidatorSet();
                if (_myData.fieldSchema.Required) {
                    validators.RegisterValidator(new SPClientForms.ClientValidation.RequiredValidator());
                }
                _myData.registerClientValidator(_myData.fieldName, validators);

                // Post DOM initialization callback.
                _myData.registerInitCallback(_myData.fieldName, function () {

                    // Initialize the input control references.
                    _phoneNrBox = document.getElementById(_inputId_PhoneNr);
                    _validationLabel = document.getElementById(_inputId_ValidationLabel);

                    // Set the initial values.
                    if (_phoneNrBox != null && _value != null) {
                        _phoneNrBox.value = _value;
                    }
                });

                // On focus call back.
                _myData.registerFocusCallback(_myData.fieldName, function () {
                    if (_phoneNrBox != null)
                        _phoneNrBox.focus();
                });

                // Validation failure handler.
                _myData.registerValidationErrorCallback(_myData.fieldName, function (errorResult) {
                    SPFormControl_AppendValidationErrorMessage(_inputId_Div, errorResult);
                });


                // Register a callback just before submit.
                _myData.registerGetValueCallback(_myData.fieldName, function () {
                    if (_phoneNrBox == null)
                        return '';
                    else {
                        return _phoneNrBox.value;
                    }
                });

                _myData.updateControlValue(_myData.fieldName, _value);
                var result = '<div width="100%" id=' + STSHtmlEncode(_inputId_Div) + '>';
                result += '<div><input id=' + STSHtmlEncode(_inputId_PhoneNr) + ' type="text" name="PhoneNr" class="ms-long" onchange="validatePhoneNumber()" /></div>';
                result += '<span class="ms-formvalidation ms-csrformvalidation" id=' + STSHtmlEncode(_inputId_ValidationLabel) + '  style="display: none;" >yup</span>'
                result += '</div>';
                return result;

            },
        };
    })();

    function _registerCustomPhoneNumberFieldTemplate() {

        var phoneNrFieldContext = {};
        phoneNrFieldContext.Templates = {};
        phoneNrFieldContext.Templates.Fields = {

            'CustomerPhoneNumber2': {
                'EditForm': CustomPhoneNumberFieldTemplate.SPFieldPhoneNumber_Edit,
                'NewForm': CustomPhoneNumberFieldTemplate.SPFieldPhoneNumber_Edit
            }
        };
        SPClientTemplates.TemplateManager.RegisterTemplateOverrides(phoneNrFieldContext);
    }
    ExecuteOrDelayUntilScriptLoaded(_registerCustomPhoneNumberFieldTemplate, 'clienttemplates.js');
})();

function validatePhoneNumber() {
    var PN_RegularExpression = /^\+\d{1,2}\-\(0\)/i;
    var result = PN_RegularExpression.exec(_phoneNrBox.value);

    if (result == null) {
        _validationLabel.style.display = "";
        _validationLabel.innerText = "Phone Number must be formatted like +[CountryCode]-(0)...";
    }
    else {
        _validationLabel.style.display = "none";
        _validationLabel.innerText = "";
    }

}