﻿using System;
using Microsoft.SharePoint;
using Microsoft.Office.RecordsManagement.RecordsRepository;

namespace WingtipToysRecordsManagement.CheckDeclareItemAsRecord
{
    /// <summary>
    /// List Item Events
    /// </summary>
    public class CheckDeclareItemAsRecord : SPItemEventReceiver
    {
        /// <summary>
        /// An item was updated.
        /// </summary>
        public override void ItemUpdated(SPItemEventProperties properties)
        {
            base.ItemUpdated(properties);

            SPListItem updatedItem = properties.ListItem;
            if (updatedItem["Status"] == "Final")
            {
                Records.DeclareItemAsRecord(updatedItem);
            }
        }
    }
}