﻿using System;
using Microsoft.SharePoint;
using Microsoft.SharePoint.WebControls;
using Microsoft.Office.Word.Server.Conversions;
using Microsoft.Office.Word.Server.Service;

namespace WingtipToysWordConversion.Layouts.WingtipToysWordConversion
{
    public partial class ConvertMeToPDF : LayoutsPageBase
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            // Only run the conversion when the page is first loaded
            if (!IsPostBack)
            {
                SPSite currentSite = SPContext.Current.Site;
                SPServiceContext serviceContext = SPServiceContext.Current;
                
                string itemUrl = Request.QueryString["ItemUrl"];
                string siteUrl = currentSite.Url.Replace(currentSite.ServerRelativeUrl, "");
                string sourceFile = siteUrl + itemUrl;
                string targetFile = sourceFile.ToLower().Replace("docx", "pdf");
                string libraryUrl = sourceFile.Remove(sourceFile.LastIndexOf('/'));

                //Get default Word Automation Service Application Proxy for the site collection
                WordServiceApplicationProxy wordProxy = serviceContext.GetDefaultProxy(
                    typeof(WordServiceApplicationProxy)) as WordServiceApplicationProxy;
                
                ConversionJobSettings jobSettings = new ConversionJobSettings();
                //SaveFormat.Automatic will try to select the format
                //based on the extension of outPuthPath
                jobSettings.OutputFormat = SaveFormat.Automatic;

                SyncConverter converter = new SyncConverter(wordProxy, jobSettings);
                converter.UserToken = currentSite.RootWeb.CurrentUser.UserToken;

                ConversionItemInfo result = converter.Convert(sourceFile, targetFile);
    
                Response.Redirect(libraryUrl);
            }
        }

    }
}
